﻿using Syncfusion.Blazor.Inputs;

namespace BlazorApp1net6.Interfaces
{
    public class FileUpload : IFileUpload
    {
        private readonly IConfiguration _configuration;
        public FileUpload(IConfiguration configuration)
        {
            _configuration = configuration;        
        }
   
        //For SfUpload Miltifiles upload
        public async Task UploadSfu(List<Syncfusion.Blazor.Inputs.UploadFiles> arg_files, string foldtypename)
        {
            var _uploadfilepath = $"{_configuration.GetValue<String>("MyWebUpload:Uploads")}\\{foldtypename}\\";

            foreach (var file in arg_files)
            {
                var filename = $"{_uploadfilepath}{file.FileInfo.Name}";

                byte[] bytes;
                FileStream fs = new FileStream(filename, FileMode.Create, FileAccess.Write, FileShare.None);

                using (var memoryStream = new MemoryStream())
                {
                    await file.Stream.CopyToAsync(memoryStream);
                    bytes = file.Stream.ToArray();
                    await fs.WriteAsync(bytes, 0, bytes.Length);
                    fs.Close();
                }
            }
        }     
    }
}
