﻿using System;
using System.Threading.Tasks;

namespace BlazorApp1net6.Interfaces
{
    public interface IRazorPage
    {
        /// <summary>
        /// 呼叫元件的 StateHasChanged()
        /// </summary>
        Task NeedRefreshAsync();
        /// <summary>
        /// 在 UI 執行緒下執行委派方法
        /// </summary>
        /// <param name="action"></param>
        /// <returns></returns>
        Task NeedInvokeAsync(Action action);
        /// <summary>
        /// 在 UI 執行緒下執行JS委派方法
        /// </summary>
        /// <param name="identifier">An identifier for the function to invoke. For example, the value <c>"someScope.someFunction"</c> will invoke the function <c>window.someScope.someFunction</c>.</param>
        /// <param name="args">JSON-serializable arguments.</param>
        Task NeedJSInvokeAsync(string identifier, params object?[]? args);
    }
}
